library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity dct2dbuf is
	generic ( width : integer := 8);
	port (	clk	: in	std_logic;
		addrin	: in	integer range 0 to 7;
		addrout	: in	integer range 0 to 7;
		we	: in	std_logic;
		rowin	: in	std_logic_vector(0 to width*8-1);
		colout	: out	std_logic_vector(0 to width*8-1)
		);
end dct2dbuf;

architecture arh of dct2dbuf is

	type buf2d is array(0 to 7) of std_logic_vector(0 to width*8-1);
	signal buf : buf2d;

	impure function get_col(addr : integer) return std_logic_vector is
		variable tmp : std_logic_vector(0 to width*8-1);
	begin
		for i in 0 to 7 loop
			tmp(i*width+0 to i*width+width-1) := buf(i)(addr*width+0 to addr*width+width-1);
		end loop;
		return tmp;
	end function;

begin

	colout <= get_col(addrout);

	process (clk) is
	begin
		if rising_edge(clk) then
			if we = '1' then
				buf(addrin) <= rowin;
			end if;
		end if;
	end process;

end arh;
