library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity memory is
	generic (	bits : integer := 8);
	port (
		clkw	: in std_logic;
		clkr	: in std_logic;
		din	: in std_logic_vector(bits-1 downto 0);
		wr	: in std_logic;
		addrw	: in unsigned(12 downto 0);
		addrr	: in unsigned(12 downto 0);
		dout	: out std_logic_vector(bits-1 downto 0)
	);
end memory;

architecture arh of memory is
	type memt is array(0 to 8191) of std_logic_vector(bits-1 downto 0);
	signal mem : memt;
begin

	writer: process (clkw)
	begin
		if rising_edge(clkw) then
			if wr = '1' then
				mem(to_integer(addrw)) <= din;
			end if;
		end if;
	end process;

	reader: process (clkr)
	begin
		if rising_edge(clkr) then
			dout <= mem(to_integer(to_01(addrr)));
		end if;
	end process;

end arh;
