library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity merger is
	port (	clk	: in	std_logic;
		reset	: in	std_logic;
		din	: in	std_logic_vector(7 downto 0);
		dine	: in	std_logic;
		dout	: out	std_logic_vector(31 downto 0);
		doute	: out	std_logic
		);
end merger;

architecture arh of merger is

	signal ptr : integer range 0 to 3;

	type word_t is array(0 to 3) of std_logic_vector(7 downto 0);
	signal regs : word_t;

begin

	dout(31 downto 24) <= regs(0);
	dout(23 downto 16) <= regs(1);
	dout(15 downto  8) <= regs(2);
	dout( 7 downto  0) <= regs(3);

	process (clk) is
	begin
		if rising_edge(clk) then
			doute <= '0';
			if dine = '1' then
				regs(ptr) <= din;
				if ptr = 3 then
					ptr <= 0;
					doute <= '1';
				else
					ptr <= ptr + 1;
				end if;
			end if;

			if reset = '1' then
				ptr <= 0;
			end if;
		end if;
	end process;

end arh;
