library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity pulsesync is
	port (	clk1	: in	std_logic;
		pulse1	: in	std_logic;
		clk2	: in	std_logic;
		pulse2	: out	std_logic
	);
end pulsesync;

architecture arh of pulsesync is

	signal tff0, dff0, dff1, dff2 : std_logic := '0';

begin

	t_bist: process (clk1)
	begin
		if rising_edge(clk1) then
			if pulse1 = '1' then
				tff0 <= not tff0;
			end if;
		end if;
	end process;

	synchain: process (clk2)
	begin
		if rising_edge(clk2) then
			dff0 <= tff0;
			dff1 <= dff0;
			dff2 <= dff1;
			pulse2 <= dff1 xor dff2;
		end if;
	end process;

end arh;
